// SceamerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Sceamer.h"
#include "SceamerDlg.h"
#include "atlimage.h"
#include "Mmsystem.h"
#include "Windows.h"
#include "math.h"
#include <fstream>
using namespace std;

#using <System.dll>
using namespace System;
using namespace System::Diagnostics;
using namespace System::ComponentModel;

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CMySceamerDlg dialog




CMySceamerDlg::CMySceamerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMySceamerDlg::IDD, pParent)
	, ScanlineDistance(200)
	, ScanlineHeight(5)
	, SoundForPicture(TRUE)
	, MouseClickForPicture(TRUE)
	, TextureImageWait(5)
	, ScanlineImageWait(2)
	, zScreen(3.5)
	, yProj(0.6)
	, wProj(1.3)
	, lProj(720)
	, yProjCam(0.3)
	, yCam(0.3)
	, wCam(1.3)
	, yScanTopCam(100)
	, yScanDistCam(350)
	, TextureFilename(_T("Texture file name"))
	, MinBrightness(50)
	, CameraPixelsPerPolygon(4)
	, zMin(1.5)
	, MaxPolygonDepth(0.05)
	, ParameterFilename(_T("Parameter file name"))
	, Status(_T(""))
	, zMax(0)
	, cProj(1280)
	, GradientThreshold(5)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	bFullscreen=false;
}

void CMySceamerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_SCANLINE_DISTANCE, ScanlineDistance);
	DDV_MinMaxUInt(pDX, ScanlineDistance, 1, 10000);
	DDX_Text(pDX, IDC_SCANLINE_HEIGHT, ScanlineHeight);
	DDV_MinMaxUInt(pDX, ScanlineHeight, 1, 10000);
	DDX_Check(pDX, IDC_SOUND_FOR_PICTURE, SoundForPicture);
	DDX_Text(pDX, IDC_TextureImageWait, TextureImageWait);
	DDV_MinMaxDouble(pDX, TextureImageWait,0, 60);
	DDX_Text(pDX, IDC_zScreen, zScreen);
	DDV_MinMaxDouble(pDX, zScreen, 0, 1000);
	DDX_Text(pDX, IDC_yProj, yProj);
	DDV_MinMaxDouble(pDX, yProj, -10, 10);
	DDX_Text(pDX, IDC_wProj, wProj);
	DDV_MinMaxDouble(pDX, wProj, 0, 1000);
	DDX_Text(pDX, IDC_lProj, lProj);
	DDV_MinMaxUInt(pDX, lProj, 1, 10000);
	DDX_Text(pDX, IDC_yProjCam, yProjCam);
	DDV_MinMaxDouble(pDX, yProjCam, -100, 100);
	DDX_Text(pDX, IDC_yCam, yCam);
	DDV_MinMaxDouble(pDX, yCam, -100, 100);
	DDX_Text(pDX, IDC_wCam, wCam);
	DDV_MinMaxDouble(pDX, wCam, 0, 100);
	DDX_Text(pDX, IDC_yScanTopCam, yScanTopCam);
	DDV_MinMaxUInt(pDX, yScanTopCam, 0, 10000);
	DDX_Text(pDX, IDC_yScanDistCam, yScanDistCam);
	DDV_MinMaxUInt(pDX, yScanDistCam, 1, 10000);
	DDX_Text(pDX, IDC_TextureFilename, TextureFilename);
	DDX_Text(pDX, IDC_MinBrightness, MinBrightness);
	DDV_MinMaxDouble(pDX, MinBrightness, 0, 100);
	DDX_Text(pDX, IDC_PixelPerPolygon, CameraPixelsPerPolygon);
	DDV_MinMaxUInt(pDX, CameraPixelsPerPolygon, 1, 100);
	DDX_Text(pDX, IDC_zMin, zMin);
	DDV_MinMaxDouble(pDX, zMin, 0, 1000);
	DDX_Text(pDX, IDC_MaxPolygonDepth, MaxPolygonDepth);
	DDV_MinMaxDouble(pDX, MaxPolygonDepth, 0, 1000);
	DDX_Check(pDX, IDC_MouseClickForPicture, MouseClickForPicture);
	DDX_Text(pDX, IDC_ScanlineImageWait, ScanlineImageWait);
	DDV_MinMaxDouble(pDX, ScanlineImageWait, 0, 10000);
	DDX_Text(pDX, IDC_ParameterFilename, ParameterFilename);
	DDX_Control(pDX, IDC_PROGRESS1, m_Progress);
	DDX_Text(pDX, IDC_STATUS_STATIC, Status);
	DDX_Text(pDX, IDC_zMax, zMax);
	DDV_MinMaxDouble(pDX, zMax, 0, 100);
	DDX_Text(pDX, IDC_cProj, cProj);
	DDV_MinMaxUInt(pDX, cProj, 1, 10000);
	DDX_Text(pDX, IDC_GradientThreshold, GradientThreshold);
	DDV_MinMaxDouble(pDX, GradientThreshold, 0, 100);
}

BEGIN_MESSAGE_MAP(CMySceamerDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_PERFORM_SCAN, &CMySceamerDlg::OnBnClickedPerformScan)
	ON_BN_CLICKED(IDC_CALCULATE, &CMySceamerDlg::OnBnClickedCalculate)
	ON_BN_CLICKED(IDC_LOAD, &CMySceamerDlg::OnBnClickedLoad)
	ON_BN_CLICKED(IDC_SAVE, &CMySceamerDlg::OnBnClickedSave)
	ON_BN_CLICKED(ID_HELP, &CMySceamerDlg::OnBnClickedHelp)
	ON_BN_CLICKED(IDC_BROWSE, &CMySceamerDlg::OnBnClickedBrowse)
	ON_BN_CLICKED(IDC_STOP, &CMySceamerDlg::OnBnClickedStop)
	ON_COMMAND(ID_STOPSCAN, &CMySceamerDlg::OnStopscan)
	ON_UPDATE_COMMAND_UI(ID_STOPSCAN, &CMySceamerDlg::OnUpdateStopscan)
	ON_BN_CLICKED(IDC_White, &CMySceamerDlg::OnBnClickedWhite)
	ON_BN_CLICKED(IDC_Scanlines, &CMySceamerDlg::OnBnClickedScanlines)
	ON_BN_CLICKED(IDC_Grid, &CMySceamerDlg::OnBnClickedGrid)
	ON_BN_CLICKED(ID_SCEAMERBLOG, &CMySceamerDlg::OnBnClickedSceamerblog)
	ON_BN_CLICKED(ID_HOMEPAGE, &CMySceamerDlg::OnBnClickedHomepage)
END_MESSAGE_MAP()


// CMySceamerDlg message handlers

BOOL CMySceamerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	//read the last settings from the registry
	CWinApp* pApp = AfxGetApp();
	ParameterFilename = pApp->GetProfileString(_T("Sceamer"), _T("ParameterFilename"), _T("Parameter File Name"));
	if (ParameterFilename!=_T("Parameter File Name")) LoadParameters();
	UpdateData(FALSE);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMySceamerDlg::OnCancel()
{
	UpdateData(TRUE);
	if (ParameterFilename!=_T("Parameter File Name")) SaveParameters();
	CDialog::OnCancel();
}

void CMySceamerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.
bool Scanning=false;
bool StopScan=false;
void CMySceamerDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{	
		if ((bFullscreen) & (!Scanning))
		{ 
			Scanning=true;
			StopScan=false;
			CPaintDC dc(this); // device context for painting
			HPEN hpa;
			HPEN hpb;
			HPEN hpr;
			hpa=CreatePen( PS_SOLID, 1, RGB(255,255,255));
			hpb=CreatePen( PS_SOLID, 1, RGB(0,0,0));
			hpr=CreatePen( PS_SOLID, 1, RGB(255,0,0));
			unsigned int mx=cProj;//GetSystemMetrics(SM_CXSCREEN);
			unsigned int my=lProj;//GetSystemMetrics(SM_CYSCREEN);
			mx--;my--;
			PumpMessages();
			if (FullScreenMode==0) {
				unsigned int i=0;
				while (i<=my) {
					dc.SelectObject( hpa);
					dc.MoveTo(0,i);
					dc.LineTo(mx,i);
					dc.LineTo(mx-1,i);
					i++;
				}

				Wait((DWORD)TextureImageWait*1000);
				if (SoundForPicture) PlaySound("sceamer.wav",NULL,SND_FILENAME);
				if (MouseClickForPicture) MouseClick();
				Wait((DWORD)ScanlineImageWait*1000);
				if (StopScan) goto EndScan;
				i=0;
				while (i<=my) {
					dc.SelectObject( hpb);
					dc.MoveTo(0,i);
					dc.LineTo(mx,i);
					dc.LineTo(mx-1,i);
					i++;
				}


				for (unsigned int k=0;k<ScanlineDistance;k+=ScanlineHeight) {
					i=my-50;
					while (i<=my) {
						dc.MoveTo(0,i);
						dc.LineTo(mx,i);
						dc.LineTo(mx-1,i);
						i++;
					}
					i=0;
					while ((i+k+ScanlineHeight)<=my) {
						dc.SelectObject( hpa);
						for (unsigned int j=0;j<ScanlineHeight;j++) {
							dc.MoveTo(0,i+k+j);
							dc.LineTo(mx,i+k+j);
							dc.LineTo(mx-1,i+k+j);
						}
						i+=ScanlineDistance;
					}
					if (SoundForPicture) PlaySound("sceamer.wav",NULL,SND_FILENAME);
					if (MouseClickForPicture) MouseClick();
					Wait((DWORD)ScanlineImageWait*1000);
					if (StopScan) goto EndScan;
					i=0;
					while ((i+k+ScanlineHeight)<=my) {
						dc.SelectObject( hpb);
						for (unsigned int j=0;j<ScanlineHeight;j++) {
							dc.MoveTo(0,i+k+j);
							dc.LineTo(mx,i+k+j);
							dc.LineTo(mx-1,i+k+j);
						}
						i+=ScanlineDistance;
					}

				}
				i=0;
				while (i<=my) {
					dc.SelectObject( hpa);
					dc.MoveTo(0,i);
					dc.LineTo(mx,i);
					dc.LineTo(mx-1,i);
					i++;
				}
				if (SoundForPicture) PlaySound("sceamer.wav",NULL,SND_FILENAME);
				if (MouseClickForPicture) MouseClick();
				Wait((DWORD)ScanlineImageWait*1000);
			} else if (FullScreenMode==1) { //white
				unsigned int i=0;
				while (i<=my) {
					dc.SelectObject( hpa);
					dc.MoveTo(0,i);
					dc.LineTo(mx,i);
					dc.LineTo(mx-1,i);
					i++;
				}
				while (!StopScan) PumpMessages();
			} else if (FullScreenMode==2) { //scanlines
				unsigned int i=0;
				while (i<=my) {
					dc.SelectObject( hpb);
					dc.MoveTo(0,i);
					dc.LineTo(mx,i);
					dc.LineTo(mx-1,i);
					i++;
				}
				unsigned int k=0;
				i=my-50;
				while (i<=my) {
					dc.MoveTo(0,i);
					dc.LineTo(mx,i);
					dc.LineTo(mx-1,i);
					i++;
				}
				i=0;
				while ((i+k+ScanlineHeight)<=my) {
					dc.SelectObject( hpa);
					for (unsigned int j=0;j<ScanlineHeight;j++) {
						dc.MoveTo(0,i+k+j);
						dc.LineTo(mx,i+k+j);
						dc.LineTo(mx-1,i+k+j);
					}
					i+=ScanlineDistance;
				}
				while (!StopScan) PumpMessages();
			} else if (FullScreenMode==3) { //grid
				unsigned int i=0;
				while (i<=my) {
					dc.SelectObject( hpa);
					dc.MoveTo(0,i);
					dc.LineTo(mx,i);
					dc.LineTo(mx-1,i);
					i++;
				}
				unsigned int k=0;
				unsigned int Distance=10;
				unsigned int Height=5;
				unsigned int GridLine=1;
				i=Distance;
				dc.SelectObject( hpb);
				while ((i+k+Height)<=my) {
					if ((GridLine%10)==0) {
						Height=5; 
						i=i-2;
					} else Height=1;
					for (unsigned int j=0;j<Height;j++) {
						dc.MoveTo(0,i+k+j);
						dc.LineTo(mx,i+k+j);
						dc.LineTo(mx-1,i+k+j);
					}
					if (Height==5) i=i+2;
					i+=Distance;
					GridLine++;
				}
				i=Distance;
				GridLine=1;
				while ((i+k+Height)<=mx) {
					if ((GridLine%10)==0) {
						Height=5; 
						i=i-2;
					} else Height=1;
					for (unsigned int j=0;j<Height;j++) {
						dc.MoveTo(i+k+j,0);
						dc.LineTo(i+k+j,my);
						dc.LineTo(i+k+j,my-1);
					}
					if (Height==5) i=i+2;
					i+=Distance;
					GridLine++;
				}

				dc.SelectObject( hpr);
				i=my/2-3;
				Height=5; 
				for (unsigned int j=0;j<Height;j++) {
					dc.MoveTo(0,i+k+j);
					dc.LineTo(mx,i+k+j);
					dc.LineTo(mx-1,i+k+j);
				}
				i+=Distance;
				GridLine++;
				
				i=mx/2-3;
				GridLine=0;
				for (unsigned int j=0;j<Height;j++) {
					dc.MoveTo(i+k+j,0);
					dc.LineTo(i+k+j,my);
					dc.LineTo(i+k+j,my-1);
				}
				i+=Distance;
				GridLine++;

				while (!StopScan) PumpMessages();
			}
EndScan:
			DeleteObject(hpa);
			DeleteObject(hpb);
			DeleteObject(hpr);
			bFullscreen=false;
			ModifyStyleEx(WS_EX_TOPMOST,0,0);
			ModifyStyle(0,WS_CAPTION,0);
			Scanning=false;
			::ShowWindow(*this,SW_MINIMIZE);
			::ShowWindow(*this,SW_NORMAL);
		}
		if (!Scanning) CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMySceamerDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CMySceamerDlg::Wait(DWORD Delay) {
	DWORD Start=GetTickCount();
	while ((GetTickCount()-Start)<Delay) ;
	PumpMessages();
}

void CMySceamerDlg::MouseClick()
{
	mouse_event(MOUSEEVENTF_LEFTDOWN,0,0,0,0);
	Wait(100);
	mouse_event(MOUSEEVENTF_LEFTUP,0,0,0,0);
}

void CMySceamerDlg::OnBnClickedLoad()
{
	UpdateData(TRUE);	
	CFileDialog FileDialog( true, _T("*.sce"), ParameterFilename, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT | OFN_FILEMUSTEXIST | OFN_PATHMUSTEXIST);
	if (FileDialog.DoModal()==IDOK) {
		ParameterFilename=FileDialog.GetPathName();
		AfxGetApp()->WriteProfileString(_T("Sceamer"), _T("ParameterFilename"),ParameterFilename);
		LoadParameters();
	}
	UpdateData(FALSE);	
	UpdateWindow();
}

void CMySceamerDlg::OnBnClickedSave()
{
	UpdateData(TRUE);
	CFileDialog FileDialog( false, _T("*.sce"), ParameterFilename, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST);
	if (FileDialog.DoModal()==IDOK) {
		ParameterFilename=FileDialog.GetPathName();		
		AfxGetApp()->WriteProfileString(_T("Sceamer"), _T("ParameterFilename"),ParameterFilename);
		SaveParameters();
	}
	UpdateData(FALSE);
	UpdateWindow();
}

void CMySceamerDlg::SaveParameters()
{
	ofstream out;
	out.open(ParameterFilename);
	out<<ScanlineDistance<<endl;
	out<<ScanlineHeight<<endl;
	out<<((SoundForPicture) ? 1 : 0)<<endl;
	out<<((MouseClickForPicture) ? 1 : 0)<<endl;
	out<<TextureImageWait<<endl;
	out<<zScreen<<endl;
	out<<yProj<<endl;
	out<<wProj<<endl;
	out<<cProj<<endl;
	out<<lProj<<endl;
	out<<yProjCam<<endl;
	out<<yCam<<endl;
	out<<wCam<<endl;
	out<<yScanTopCam<<endl;
	out<<yScanDistCam<<endl;
	out<<TextureFilename<<endl;
	out<<MinBrightness<<endl;
	out<<GradientThreshold<<endl;
	out<<CameraPixelsPerPolygon<<endl;
	out<<zMin<<endl;
	out<<zMax<<endl;
	out<<MaxPolygonDepth<<endl;
	out<<ScanlineImageWait<<endl;
	out.close();
}

void CMySceamerDlg::LoadParameters()
{
	ifstream in(ParameterFilename);
	if (in.eof()) return;
	char Line[1000];
	in.getline(Line,1000);
	ScanlineDistance=atoi(Line);
	in.getline(Line,1000);
	ScanlineHeight=atoi(Line);
	in.getline(Line,1000);
	SoundForPicture=atoi(Line)==1;
	in.getline(Line,1000);
	MouseClickForPicture=atoi(Line)==1;
	in.getline(Line,1000);
	TextureImageWait=atof(Line);
	in.getline(Line,1000);
	zScreen=atof(Line);
	in.getline(Line,1000);
	yProj=atof(Line);
	in.getline(Line,1000);
	wProj=atof(Line);
	in.getline(Line,1000);
	cProj=atoi(Line);
	in.getline(Line,1000);
	lProj=atoi(Line);
	in.getline(Line,1000);
	yProjCam=atof(Line);
	in.getline(Line,1000);
	yCam=atof(Line);
	in.getline(Line,1000);
	wCam=atof(Line);
	in.getline(Line,1000);
	yScanTopCam=atoi(Line);
	in.getline(Line,1000);
	yScanDistCam=atoi(Line);
	in.getline(Line,1000);
	TextureFilename.Format("%s",Line);
	in.getline(Line,1000);
	MinBrightness=atof(Line);
	in.getline(Line,1000);
	GradientThreshold=atof(Line);
	in.getline(Line,1000);
	CameraPixelsPerPolygon=atoi(Line);
	in.getline(Line,1000);
	zMin=atof(Line);
	in.getline(Line,1000);
	zMax=atof(Line);
	in.getline(Line,1000);
	MaxPolygonDepth=atof(Line);
	in.getline(Line,1000);
	ScanlineImageWait=atof(Line);
	in.close();
}

void CMySceamerDlg::OnBnClickedHelp()
{
	if (Scanning) StopScan=true; else {
		char buf[500];
		GetModuleFileName(NULL,buf,500);
		size_t l=strlen(buf);
		while ((l>0) && (buf[l]!='\\')) l--;
		buf[l]=0;

		/*while (l>0) {
			if (buf[l]=='\\') buf[l]='/';
			l--;
		}*/

		CString HelpName;
		HelpName.Format("%s\\sceamer_help.pdf",buf);
		strcpy_s(buf,500,HelpName);
		System::String ^ buf2= gcnew String(buf); 
		Process::Start(buf2);
	}
}

void CMySceamerDlg::OnBnClickedBrowse()
{
	UpdateData(TRUE);	
	CFileDialog FileDialog( true, _T("*.jpg"), TextureFilename, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT | OFN_FILEMUSTEXIST | OFN_PATHMUSTEXIST);
	if (FileDialog.DoModal()==IDOK) {
		TextureFilename=FileDialog.GetPathName();
	}
	UpdateData(FALSE);	
	UpdateWindow();
}

class TGAFile {
  public:
	TGAFile();
	void WriteTGAFile(const char* name,unsigned long width,unsigned long height,unsigned short *bitmap);
	bool ReadTGAFile(const char* name,unsigned long &width,unsigned long &height,unsigned short *&bitmap);
	~TGAFile();
};

TGAFile::TGAFile() {
}

void TGAFile::WriteTGAFile(const char* name,unsigned long width,unsigned long height,unsigned short *bitmap) {
  int maxpos;
  unsigned char *zeile;
  FILE *stream;
  int open;  
//  struct diskfree_t free;
  //long avail;
  maxpos=width;
  zeile=NULL;
/*  if (_dos_getdiskfree(0, &free)!=0) avail=0; else
  avail=(long) free.avail_clusters
		  * (long) free.bytes_per_sector
		  * (long) free.sectors_per_cluster; */
  long int filesize;
  filesize=width*height*2+18;
  //if (avail<filesize) open=0; else {
	 open=1;
	 fopen_s(&stream,name,"wb");
    putc(0,stream); // no ID
    putc(0,stream); // no color table
	putc(3,stream);                         /* uncompressed monochrome */
    putc(0,stream); putc(0,stream); //start palette
    putc(0,stream); putc(0,stream);   //length palette
	putc(16,stream); //witdth of palette in bits
    putc(0,stream); putc(0,stream);           /* X origin */
    putc(0,stream); putc(0,stream);           /* y origin */
    putc((width & 0x00FF),stream);
    putc((width & 0xFF00) / 256,stream); //width
    putc((height & 0x00FF),stream);
    putc((height & 0xFF00) / 256,stream); //height
    putc(16,stream);                        /* 16 bit bitmap */
    putc(0,stream);
	zeile=new unsigned char[2*width];	
	unsigned short* bm=bitmap;
	for (unsigned int i=0;i<height;i++) {
		for (unsigned int j=0;j<width;j++) {
			zeile[j*2]=(unsigned char)(*bm & 0x00FF);
			zeile[j*2+1]=(unsigned char)((*bm & 0xFF00) / 256) ;  			
			bm++;
		}
		fwrite(zeile,1,maxpos*2,stream);		
	}
	delete zeile;
	zeile=NULL;
	fclose(stream);
//  }
}

TGAFile::~TGAFile()
{
	//if (zeile) delete zeile;
	//zeile=NULL;
}

bool TGAFile::ReadTGAFile(const char* name,unsigned long &width,unsigned long &height,unsigned short *&bitmap) {
	int hoehe,breite;
	int position;
	unsigned char *zeile;  	
	zeile=NULL;
	position=0;
	FILE* bild;  
	fopen_s(&bild,name,"rb");
	bool error=true;
	if (bild) {    
		error=false;
		error=error || getc(bild)!=0;
		error=error || getc(bild)!=0;
		error=error || getc(bild)!=3;
		for (int i=0;i<9;i++) error=error || getc(bild)!=0;
		unsigned char help1=getc(bild);//inforce read order
		unsigned char help2=getc(bild);		
		breite=help1+help2*256;
		help1=getc(bild);
		help2=getc(bild);				
		hoehe=help1+help2*256;		
		error=error || getc(bild)!=16;
		error=error || getc(bild)!=0;    
		if (error) fclose(bild);		
		else  {
			zeile=new unsigned char[2*breite];		
			width=breite;
			height=hoehe;
			if (bitmap) delete bitmap;
			bitmap = new unsigned short[width*height];		
			unsigned short* bm=bitmap;
			for (unsigned int i=0;i<height;i++) {			
				fread(zeile,1,2*width,bild);
				for (unsigned int j=0;j<width;j++) {				
					*bm=zeile[j*2]+zeile[j*2+1]*256;  				
					bm++;
				}						
			} 
			fclose(bild);  
			delete zeile;  
			zeile=NULL;
		}	 	
	}
	return error;
};

void CMySceamerDlg::SetData(CString text, int SubProgressPosition,int SubProgressMax,int Unit, int MaxUnits)
{
	Status=text;
	int ProgressPosition=Unit*1000+SubProgressPosition*1000/SubProgressMax;
	int ProgressMax=MaxUnits*1000;
	m_Progress.SetRange32( 0,ProgressMax);
	m_Progress.SetPos(ProgressPosition);	
	UpdateData(FALSE);
	PumpMessages();
}

void CMySceamerDlg::PumpMessages() {
	MSG msg;
	while ( ::PeekMessage( &msg, NULL, 0, 0, PM_NOREMOVE ) ) 
	{ 
		if ( !AfxGetApp ()->PumpMessage( ) ) 
		{ 	       
	       ::PostQuitMessage( 0); 
		    break; 
		} 
	} 
	// let MFC do its idle processing
	LONG lIdle = 0;
	//while ( 
		AfxGetApp()->OnIdle(lIdle++ );// )	;  
	// Perform some background processing here 
	// using another call to OnIdle	
}


const int MaxCol=7;
const COLORREF Palette[MaxCol]={RGB(0,0,0),RGB(255,0,0),RGB(0,255,0),RGB(0,0,255),RGB(255,255,0),RGB(255,0,255),RGB(0,255,255)};

bool StopCalculation=false;
void CMySceamerDlg::OnBnClickedCalculate()
{
	//Coordinate system:
	//cartesion, units meter, z is depth, y up, x to the left.
	//beamer lens at origin
	//camera lens straight below beamer
	//virtual projection screen thought to be orthogonal to beamer at distance zScreen
	//camera can be rotated and tilted relative to projection screen center
	//beamer image just shifted on projection screen, not tilted.
	//

	/*
	//CString	 TextureFilename  //Filename Format: PA230034.JPG PA23%04u.JPG
	//Example Parameters:
	//Description of Beamer
	const double zScreen=3.4; //Distance from beamer to maximum distance in meter
	const double yProj=0.6; //distance of upper boarder of beamer beams at maximum distance relative to beamer height in meter
	const double lProj=720; //Number of lines of beamer
	const double cProj=1280; //Number of columns of beamer
	const double hProj=1.3; //Height of beamer projection at zScreen in meter
	const double DeltaYBeamer=hProj/lProj;  //0.001875; //Beamer Pixelsize at maximum distance in meter
	const double ScanlineDistance=160; //Distance of two light sheets from beamer in Beamer lines
	const double ScanlineHeight=4; Width of light sheet in Beamer pixel
	const unsigned int NrImages=(unsigned int)ScanlineDistance/ScanlineHeight;  //Number of different light sheet positions = Number of Pixtures without the texture picture

	//Description of Camera
	const double yProjCam=0.33; //distance between beamer and camera in meter. Camera lens is supposed to be vertically below beamer lens
	const double yCam=0.3; //distance of first camera line in distance zScreen relative to height of beamer in meter
	const double MaxCameraLines=1712;  //Camera height in pixel
	const double hCam=2*xCam*Height/Width; //Height of camera picture in meter at distance zScreen
	const double DeltaYCamera=hCam/MaxCameraLines;//0.001125; //vertical Size of camera pixels in distance zScreen
	const double DeltaXCamera=DeltaYCamera; //horizontal Size of camera pixels in distance zScreen
	const double CameraWidth=2288; //Width of camera in pixel
	const double xCam=CameraWidth/2*DeltaXCamera; //Distance between camera viewing area start left to origin at zScreen
	const int StartLineNumber=150;// //First line with usable data on camera images
	const double yScanTopCam=314;//  //camera line of highest beam on first picture as it hits zScreen
	const double yScanDistCam=271;
	
	const int ThreshholdBrightness=50; //Minimum Brightness a pixel must have to be considered in the beam
	const int MinBrightness=50; //Minimum Brightness for valid vertex

	//Output parameters
	const int CameraPixelsPerPolygon=4;
	const double zMin=1.5; //Minimum distance in meter for depthmap
	const double zMax=zScreen;
	const double MaxPolygonDepth=0.05; //Maximum z distance for a valid polygon in meter
	*/


	StopCalculation=false;
	UpdateData(TRUE);
	if (zMax==zMin) zMax=zMin+1;
	SaveParameters();

	CImage *ResultImage=NULL;
	CImage *BrightnessImage=NULL;
	double *objxLowRes=NULL;
	double *objyLowRes=NULL;
	double *objzLowRes=NULL;
	int *BrightnessLowRes=NULL;
	CImage *AktImage=NULL;
	unsigned int *Brightness=NULL;
	double *objx=NULL;
	double *objy=NULL;
	double *objz=NULL;
	int *SourcePicture=NULL;
	int *BeamNrMatrix=NULL;
	double *CameraPixelSizeY=NULL;
	double *SumOfPixelSizeTillY=NULL;
	double *xCamAt=NULL;
	unsigned short *DepthMap16Bit=NULL;
	unsigned short *Gradient=NULL;
	unsigned char *Resolution=NULL;
	long *VertexNumberHighRes=NULL;
	long *VertexNumberLowRes=NULL;
	bool *VerticeLowResOk=NULL;
	bool *VerticeOk=NULL;
	
	TGAFile hTGAFile;
	CString buf;

	//create material file with link to texture
	CString AktFileName;
	char Path[500];
	char Filename[500];
	strcpy_s(Filename,500,TextureFilename);
	size_t l=strlen(Filename);
	char StartNrString[10];
	strncpy_s(StartNrString,&(Filename[l-8]),4);
	StartNrString[4]=0;
	unsigned int StartPicNr=atoi(StartNrString);
	Filename[l-8]='%';
	Filename[l-7]='0';
	Filename[l-6]='4';
	Filename[l-5]='u';	
	strcpy_s(Path,500,TextureFilename);
	size_t i=strlen(Path)-1;
	while ((i>0) && (Path[i]!='\\')) {
		Path[i]=0;
		i--;
	}
	strcat_s(Path,500,"%s");
	
	int Height;
	int Width;

	AktFileName.Format(Filename,0);
	char objFileName[500];
	strcpy_s(objFileName,500,AktFileName);
	l=AktFileName.GetLength();
	objFileName[l-3]='o';
	objFileName[l-2]='b';
	objFileName[l-1]='j';

	char mtlFileName[500];
	strcpy_s(mtlFileName,objFileName);
	mtlFileName[l]='.';
	mtlFileName[l+1]='m';
	mtlFileName[l+2]='t';
	mtlFileName[l+3]='l';
	mtlFileName[l+4]=0;
	
	ofstream mtl(mtlFileName);
	ofstream obj(objFileName);

	AktFileName.Format(Filename,StartPicNr);
	ResultImage=new CImage();
	HRESULT result=ResultImage->Load(AktFileName);
	if (result!=S_OK) {
		CString buf;
		buf.Format("File not found:\n %s",AktFileName);
		AfxMessageBox(buf);
		goto EndCalculation;
	}
	BrightnessImage=new CImage();
	result=BrightnessImage->Load(AktFileName);
	if (result!=S_OK) {
		CString buf;
		buf.Format("File not found:\n %s",AktFileName);
		AfxMessageBox(buf);
		goto EndCalculation;
	}
	Width=ResultImage->GetWidth();
	Height=ResultImage->GetHeight();
	Brightness=new unsigned int[Width*Height];
	objx=new double[Width*Height];
	objy=new double[Width*Height];
	objz=new double[Width*Height];
	SourcePicture=new int[Width*Height];
	BeamNrMatrix=new int[Width*Height];
	for (int x=0;x<Width;x++) for (int y=0;y<Height;y++) {
		Brightness[x+y*Width]=0;
		objx[x+y*Width]=0;
		objy[x+y*Width]=0;
		objz[x+y*Width]=zMax;
		SourcePicture[x+y*Width]=-1;
		BeamNrMatrix[x+y*Width]=-1;
	}

	//Determine LineNr and PicNr of each pixel
	StartPicNr++;  //Texture image is the first image. To extract depth, we need the other images
	double BeamerStartLineNumber;
	unsigned int NrImages=(unsigned int)ScanlineDistance/ScanlineHeight;
	for (unsigned int i=0;i<NrImages;i++) {	
		CString buf;
		buf.Format("Loading image %04u / %04u",i+1,NrImages);
		SetData(buf,i+1,NrImages,0,9);		
		if (StopCalculation) goto EndCalculation;
		unsigned int PicNr=i;
		AktFileName.Format(Filename,PicNr+StartPicNr);
		AktImage=new CImage();
		HRESULT result=AktImage->Load(AktFileName);
		if (result!=S_OK) {
			CString buf;
			buf.Format("File not found:\n %s",AktFileName);
			AfxMessageBox(buf);
			goto EndCalculation;
		}
		unsigned char *AktImageBitmap;
		for (int y=0;y<Height;y++) {
			double h=yScanDistCam;
			h=h/NrImages;
			double BeamNrD=( y - ( yScanTopCam + PicNr*h ) );
			BeamNrD=BeamNrD/yScanDistCam;
			int BeamNr=(int)(floor(BeamNrD)+1);
			AktImageBitmap=(unsigned char*)AktImage->GetPixelAddress(0,y);
			for (int x=0;x<Width;x++) {
				if ((x%100)==0) AktImageBitmap=(unsigned char*)AktImage->GetPixelAddress(x,y);
				unsigned int AktBright=*AktImageBitmap;
				AktImageBitmap++;
				AktBright+=*AktImageBitmap;
				AktImageBitmap++;
				AktBright+=*AktImageBitmap;
				AktImageBitmap++;
				if ((AktBright>Brightness[x+y*Width]) && (AktBright>(8*MinBrightness))) {
					Brightness[x+y*Width]=AktBright;
					SourcePicture[x+y*Width]=PicNr;
					BeamNrMatrix[x+y*Width]=BeamNr;
				}
			}
		}
		delete AktImage;
		AktImage=NULL;
	}
	
	buf.Format("Calculate depthmap  %04u / %04u",0,Width);
	SetData(buf,0,Width,1,9);	
	if (StopCalculation) goto EndCalculation;
	//The projector is oriented exactly orthogonal to the screen. Its shift lens objective guarantees constant pixelsize over the whole screen, independent on the position of the illuminated area
	//The camera is not necessarily oriented orthogonal to the screen. Most often it will be tilted vertically, but not horizontally. As a consequence the pixelsize changes on the screen with vertical position.
	//We have to correct for this changing pixel size
	const double M_PI=3.14159265;
	CameraPixelSizeY= new double[Height];
	SumOfPixelSizeTillY= new double[Width];
	xCamAt= new double[Height];
	double l1=sqrt(zScreen*zScreen+(yProjCam-yCam)*(yProjCam-yCam));
	double xCam=wCam*0.5;
	double l3=2*xCam*Height/Width;
	double alpha4=atan((yProjCam-yCam)/zScreen);
	double alpha2=acos((l3*0.5)/l1);
	double alpha3=M_PI*0.5-alpha4-alpha2;
	double alpha1=M_PI*0.5-alpha2;
	double alpha5=alpha3+alpha1;
	double l4=zScreen*tan(alpha5);
	double hCam=yProjCam-yCam+l4;
	double l2=sqrt(zScreen*zScreen+l4*l4);
	SumOfPixelSizeTillY[0]=0;
	xCamAt[0]=xCam;
	for (int y=1;y<Height;y++) {
		double lpn=l3*y/Height;
		SumOfPixelSizeTillY[y]=lpn*cos(alpha3);
		CameraPixelSizeY[y-1]=SumOfPixelSizeTillY[y]-SumOfPixelSizeTillY[y-1];
		xCamAt[y]=xCam+xCam*(l2/l1-1)*SumOfPixelSizeTillY[y]/hCam;
	}
	CameraPixelSizeY[Height-1]=CameraPixelSizeY[Height-2];

	//calculate spatial coordinates
	double hProj=wProj*lProj/cProj;
	double DeltaYBeamer=hProj/lProj;
	for (int x=0;x<Width;x++) {
		if ((x % 100)==0) {
			CString buf;
			buf.Format("Calculate depthmap  %04u / %04u",x+1,Width);
			SetData(buf,x+1,Width,1,9);
			if (StopCalculation) goto EndCalculation;
		}
		int AktPicNr=-99;
		int AktSubYRegionLength=1;
		int AktSubYRegionStart=0;
		for (int y=0;y<Height;y++) {
			if (AktPicNr!=SourcePicture[x+y*Width]) {
				AktSubYRegionStart=y;
				AktPicNr=SourcePicture[x+y*Width];
				AktSubYRegionLength=1;
				while (((y+AktSubYRegionLength)<Height) && (SourcePicture[x+(y+AktSubYRegionLength)*Width]==AktPicNr)) AktSubYRegionLength++;
			}
			BeamerStartLineNumber=SourcePicture[x+y*Width]*ScanlineHeight;
			double BeamerLineNr=BeamerStartLineNumber+ScanlineDistance*BeamNrMatrix[x+y*Width];
			double h=ScanlineHeight;
			h=h*(y-AktSubYRegionStart);
			BeamerLineNr=BeamerLineNr+h/AktSubYRegionLength;
			double YSB=yProj+BeamerLineNr*DeltaYBeamer;
			double YSC=yCam+SumOfPixelSizeTillY[y];
			double oz=yProjCam*zScreen/(yProjCam-YSC+YSB);
			if (SourcePicture[x+y*Width]==-1) oz=zMax;
			double oy=-YSB*oz/zScreen;
			objz[x+y*Width]=oz;
			objy[x+y*Width]=oy;
			double XSC=xCamAt[y]-CameraPixelSizeY[y]*x;
			objx[x+y*Width]=XSC*oz/zScreen;
		}
	}

	//Store Depthmap
	//AktFileName.Format(Path,"depthmap.bmp");
	//ResultImage->Save(AktFileName); 

	//Store PictureNumberMap
	SetData("Store PictureNumberMap",1,7,2,9);
	if (StopCalculation) goto EndCalculation;
	AktFileName.Format(Path,"PictureNumberMap.bmp");
	const int MaxCol=7;
	COLORREF Palette[MaxCol]={RGB(0,0,0),RGB(255,0,0),RGB(0,255,0),RGB(0,0,255),RGB(255,255,0),RGB(255,0,255),RGB(0,255,255)};
	for (int y=0;y<Height;y++) {
		unsigned char* AktImageBitmap=(unsigned char*)ResultImage->GetPixelAddress(0,y);
		for (int x=0;x<Width;x++) {
			if ((x%100) ==0) AktImageBitmap=(unsigned char*)ResultImage->GetPixelAddress(x,y);
			*AktImageBitmap=GetRValue(Palette[((SourcePicture[x+y*Width]+1) % MaxCol)]);
			AktImageBitmap++;
			*AktImageBitmap=GetGValue(Palette[((SourcePicture[x+y*Width]+1) % MaxCol)]);
			AktImageBitmap++;
			*AktImageBitmap=GetBValue(Palette[((SourcePicture[x+y*Width]+1) % MaxCol)]);
			AktImageBitmap++;
			//ResultImage->SetPixel(x,y,Palette[((SourcePicture[x+y*Width]+1) % MaxCol)]);
		}
	}
	ResultImage->Save(AktFileName);
	

	//Store BeamNrMap
	SetData("Store BeamNumberMap",2,7,2,9);
	if (StopCalculation) goto EndCalculation;
	AktFileName.Format(Path,"BeamNumberMap.bmp");
	for (int y=0;y<Height;y++) {
		unsigned char* AktImageBitmap=(unsigned char*)ResultImage->GetPixelAddress(0,y);
		for (int x=0;x<Width;x++) {
			if ((x%100) ==0) AktImageBitmap=(unsigned char*)ResultImage->GetPixelAddress(x,y);
			*AktImageBitmap=GetRValue(Palette[((BeamNrMatrix[x+y*Width]+1) % MaxCol)]);
			AktImageBitmap++;
			*AktImageBitmap=GetGValue(Palette[((BeamNrMatrix[x+y*Width]+1) % MaxCol)]);
			AktImageBitmap++;
			*AktImageBitmap=GetBValue(Palette[((BeamNrMatrix[x+y*Width]+1) % MaxCol)]);
			AktImageBitmap++;
			//ResultImage->SetPixel(x,y,Palette[((BeamNrMatrix[x+y*Width]+1) % MaxCol)]);
		}
	}
	ResultImage->Save(AktFileName);

	//Store 8bit Depthmap BeamNrMap
	SetData("Store DepthMap.bmp",3,7,2,9);
	if (StopCalculation) goto EndCalculation;
	AktFileName.Format(Path,"DepthMap.bmp");
	for (int y=0;y<Height;y++) {
		unsigned char* Bitmap=(unsigned char*)ResultImage->GetPixelAddress(0,y);
		for (int x=0;x<Width;x++) {
			if ((x%100) ==0) Bitmap=(unsigned char*)ResultImage->GetPixelAddress(x,y);
			double DepthScaled=255*(zMax-objz[x+y*Width])/(zMax-zMin);
			if (DepthScaled>255) DepthScaled=255;
			else if (DepthScaled<0) DepthScaled=0;
			unsigned char Depth=(unsigned char)DepthScaled;
			*Bitmap=Depth;
			Bitmap++;
			*Bitmap=Depth;
			Bitmap++;
			*Bitmap=Depth;
			Bitmap++;
		}
	}
	ResultImage->Save(AktFileName);

	//Write 16bit Depthmap
	SetData("Store DepthMap.TGA",4,7,2,9);
	if (StopCalculation) goto EndCalculation;
	AktFileName.Format(Path,"DepthMap16bit.TGA");
	DepthMap16Bit=new unsigned short[Width*Height];

	for (int i=0;i<Height;i++) {
		for (int j=0;j<Width;j++) {
			double DepthScaled=0xFFFF*(zMax-objz[j+Width*i])/(zMax-zMin);
			if (DepthScaled>0xFFFF) DepthScaled=0xFFFF;
			else if (DepthScaled<0) DepthScaled=0;
			DepthMap16Bit[j+Width*(Height-1-i)]=(unsigned short)DepthScaled;
		}
	}

	
	
	hTGAFile.WriteTGAFile(AktFileName,Width,Height,DepthMap16Bit);

	//create and save gradient image

	Gradient=new unsigned short[Width*Height];
	SetData("Store EdgeMap.bmp",5,7,2,9);
	if (StopCalculation) goto EndCalculation;
	for (int x=1;x<Width;x++) Gradient[x+0*Width]=0;
	for (int y=1;y<Height;y++) {
		Gradient[0+y*Width]=0;
		for (int x=1;x<Width;x++) {
			double help=(DepthMap16Bit[x+Width*(Height-1-y)]-DepthMap16Bit[(x-1)+Width*(Height-1-y)]);
			double help2=(DepthMap16Bit[x+Width*(Height-1-y)]-DepthMap16Bit[x+Width*(Height-1-(y-1))]);
			Gradient[x+y*Width]=(unsigned short)(sqrt((help*help+help2*help2)/2));
		}
	}

	for (int y=0;y<Height;y++) {
		unsigned char* Bitmap=(unsigned char*)BrightnessImage->GetPixelAddress(0,y);
		for (int x=0;x<Width;x++) {
			if ((x%100) ==0) Bitmap=(unsigned char*)BrightnessImage->GetPixelAddress(x,y);
			unsigned char AktBright=(unsigned char)(Gradient[x+y*Width]/256);
			*Bitmap=AktBright;
			Bitmap++;
			*Bitmap=AktBright;
			Bitmap++;
			*Bitmap=AktBright;
			Bitmap++;
			//BrightnessImage->SetPixel(x,y,RGB(AktBright,AktBright,AktBright));
		}
	}
	AktFileName.Format(Path,"EdgeMap.bmp");
	BrightnessImage->Save(AktFileName);

	//create and save resolution image
	Resolution=new unsigned char[Width*Height];
	SetData("Store ResolutionMap.bmp",6,7,2,9);

	//Depthmap is scaled from zMin to zMax: zMax-zMin deep
	//Pixelsize is roughly CamPixelSize=2*xCam/Width
	//maximum Gradient in one dimension (Gradient=sqrt(0xFFFF/2)) is (zMax-zMin)/CamPixelSize;
	//GradientThreshold is given in depth / lateral distance
	//in the units of our gradient field this is:
	//
	
	/*double CamPixelSize=wCam/Width;
	double MaxDepth=zMax-zMin;
	//GradientThreshold:MaxDepth/LateralDistance
	//GradientThreshold per Pixelsize= GradientThreshold*CamPixelSize;
	double dGradientThreshold=(GradientThreshold*CamPixelSize*sqrt(0.5)*0xFFFF/MaxDepth);
	if (dGradientThreshold>0xFFFF) dGradientThreshold=0xFFFF;
	if (dGradientThreshold<0) dGradientThreshold=0;
	unsigned short hGradientThreshold=(unsigned short)dGradientThreshold;*/
	unsigned short hGradientThreshold=(unsigned short)(GradientThreshold*0xFFFF/100);
	//Resolution: 0: not defined yet, 1: low res, 2,3: high res 3:edge
	for (unsigned int y=0;y<(unsigned int)Height;y++) for (unsigned int x=0;x<(unsigned int)Width;x++) Resolution[x+y*Width]=0;
	for (unsigned int y=0;y<(unsigned int)Height;y++) {
		for (unsigned int x=0;x<(unsigned int)Width;x++) {
			if (Gradient[x+y*Width]>hGradientThreshold) {
				Resolution[x+y*Width]=3;
				double hx=x;
				double hy=y;
				unsigned int xlowres=((unsigned int)(floor(hx/CameraPixelsPerPolygon)))*CameraPixelsPerPolygon;
				unsigned int ylowres=((unsigned int)(floor(hy/CameraPixelsPerPolygon)))*CameraPixelsPerPolygon;
				for (int bpx=-1;bpx<2;bpx++) for (int bpy=-1;bpy<2;bpy++) {
				//int bpx=0;
				//int bpy=0; 
				//{
					for (unsigned int k=0;k<CameraPixelsPerPolygon;k++) {
						for (unsigned int j=0;j<CameraPixelsPerPolygon;j++) {
							unsigned long Adr=(xlowres+k+bpx*CameraPixelsPerPolygon)+(ylowres+j+bpy*CameraPixelsPerPolygon)*Width;
							if ((Adr<(unsigned long)(Height*Width)) && (Resolution[Adr]!=3)) {
								if ((bpx==0) && (bpy==0)) Resolution[Adr]=2; else if (Resolution[Adr]!=2) Resolution[Adr]=4;
							}
						}
					}
				}
			} else {
				if (Resolution[x+y*Width]==0) Resolution[x+y*Width]=1;
			}
		}
	}
	
	for (int y=0;y<Height;y++) {
		unsigned char* Bitmap=(unsigned char*)BrightnessImage->GetPixelAddress(0,y);
		for (int x=0;x<Width;x++) {
			if ((x%100) ==0) Bitmap=(unsigned char*)BrightnessImage->GetPixelAddress(x,y);
			if (Resolution[x+y*Width]==3) {
				*Bitmap=0; //blue
				Bitmap++;
				*Bitmap=0; //green
				Bitmap++;
				*Bitmap=255; //red
				Bitmap++;
			} else if (Resolution[x+y*Width]==4) {
				*Bitmap=255; //blue
				Bitmap++;
				*Bitmap=255; //green
				Bitmap++;
				*Bitmap=255; //red
				Bitmap++;
			} else if (Resolution[x+y*Width]==2) {
				*Bitmap=0; //blue
				Bitmap++;
				*Bitmap=255; //green
				Bitmap++;
				*Bitmap=255; //red
				Bitmap++;
			} else {
				*Bitmap=0;
				Bitmap++;
				*Bitmap=0;
				Bitmap++;
				*Bitmap=0;
				Bitmap++;
			}
			//BrightnessImage->SetPixel(x,y,RGB(AktBright,AktBright,AktBright));
		}
	}
	AktFileName.Format(Path,"ResolutionMap.bmp");
	BrightnessImage->Save(AktFileName);

	//create and save Brightness image
	SetData("Store Brightness.bmp",7,7,2,9);
	if (StopCalculation) goto EndCalculation;
	for (int y=0;y<Height;y++) {
		unsigned char* Bitmap=(unsigned char*)BrightnessImage->GetPixelAddress(0,y);
		for (int x=0;x<Width;x++) {
			if ((x%100) ==0) Bitmap=(unsigned char*)BrightnessImage->GetPixelAddress(x,y);
			unsigned char AktBright=(unsigned char)(Brightness[x+y*Width]/3);
			*Bitmap=AktBright;
			Bitmap++;
			*Bitmap=AktBright;
			Bitmap++;
			*Bitmap=AktBright;
			Bitmap++;
			//BrightnessImage->SetPixel(x,y,RGB(AktBright,AktBright,AktBright));
		}
	}
	AktFileName.Format(Path,"Brightness.bmp");
	BrightnessImage->Save(AktFileName);

	SetData("Calculate mesh",1,1,3,9);
	if (StopCalculation) goto EndCalculation;

	//bounding box
	for (int y=0;y<Height;y++) {
		for (int x=0;x<Width;x++) {
			long Adr=x+y*Width;
			if ((objx[Adr]>100) || (objx[Adr]<-100) ||
				(objy[Adr]>100) || (objy[Adr]<-100) ||
				(objz[Adr]>100) || (objz[Adr]<-100) ) {
						objx[Adr]=0;
						objy[Adr]=0;
						objz[Adr]=0;
						Brightness[Adr]=0;
			}
		}
	}

	//Calculate low resolution vertices to reduce number of polygons
	int WidthLowRes=(Width/CameraPixelsPerPolygon)-1;
	int HeightLowRes=(Height/CameraPixelsPerPolygon)-1;
	int PixelShift=CameraPixelsPerPolygon/2;
	PixelShift=-PixelShift;

	objxLowRes=new double[WidthLowRes*HeightLowRes];
	objyLowRes=new double[WidthLowRes*HeightLowRes];
	objzLowRes=new double[WidthLowRes*HeightLowRes];
	BrightnessLowRes=new int[WidthLowRes*HeightLowRes];
	int yh=0;
	for (int y=PixelShift;y<(int)(Height-CameraPixelsPerPolygon);y=y+CameraPixelsPerPolygon) {
		int xh=0;
		for (int x=PixelShift;x<(int)(Width-CameraPixelsPerPolygon);x=x+CameraPixelsPerPolygon)  {
			//test if this vertex of the low res lattice is neighboring a high res lattice
			bool Neighboring=false;
			long TestAdr=xh+yh*Width;
			Neighboring=Resolution[TestAdr*CameraPixelsPerPolygon]>1;
			TestAdr=xh+(yh-1)*Width;
			if (TestAdr>0) {
				Neighboring=Neighboring || (Resolution[TestAdr*CameraPixelsPerPolygon]>1);
			}
			TestAdr=xh-1+yh*Width;
			if (TestAdr>0) {
				Neighboring=Neighboring || (Resolution[TestAdr*CameraPixelsPerPolygon]>1);
			}
			TestAdr=xh-1+(yh-1)*Width;
			if (TestAdr>0) {
				Neighboring=Neighboring || (Resolution[TestAdr*CameraPixelsPerPolygon]>1);
			}
			if (Neighboring) {
				//set this vertex equal to equivalent high res vertex
				long Adr=x-PixelShift+(y-PixelShift)*Width;
				objxLowRes[xh+yh*WidthLowRes]=objx[Adr];
				objyLowRes[xh+yh*WidthLowRes]=objy[Adr];
				objzLowRes[xh+yh*WidthLowRes]=objz[Adr];
				BrightnessLowRes[xh+yh*WidthLowRes]=Brightness[Adr];
			} else {
				//calculate averaged vertex
				double oxa=0;
				double oya=0;
				double oza=0;
				double ba=0;
				int N=0;
				for (unsigned int ys=0;ys<CameraPixelsPerPolygon;ys++) {
					for (unsigned int xs=0;xs<CameraPixelsPerPolygon;xs++) {
						long Adr=x+xs+(y+ys)*Width;
						if ((Adr>0) && (Adr<(Width*Height))) {
							if ((Brightness[Adr]>(8*MinBrightness)) ) {
								oxa=oxa+objx[Adr];
								oya=oya+objy[Adr];
								oza=oza+objz[Adr];
								ba=ba+Brightness[Adr];
								N++;
							}
						}
					}
				}
				if (N>0) {
					oxa=oxa/N;
					oya=oya/N;
					oza=oza/N;
					ba=ba/N;
					objxLowRes[xh+yh*WidthLowRes]=oxa;
					objyLowRes[xh+yh*WidthLowRes]=oya;
					objzLowRes[xh+yh*WidthLowRes]=oza;
					BrightnessLowRes[xh+yh*WidthLowRes]=(int)ba;
				} else {
					objxLowRes[xh+yh*WidthLowRes]=0;
					objyLowRes[xh+yh*WidthLowRes]=0;
					objzLowRes[xh+yh*WidthLowRes]=0;
					BrightnessLowRes[xh+yh*WidthLowRes]=0;
				}
			}
			xh++;
			if (xh>=WidthLowRes) xh=WidthLowRes-1;
		}
		if (xh<WidthLowRes) {
			for (int i=xh;i<WidthLowRes;i++) {
				objxLowRes[i+yh*WidthLowRes]=0;
				objyLowRes[i+yh*WidthLowRes]=0;
				objzLowRes[i+yh*WidthLowRes]=0;
				BrightnessLowRes[i+yh*WidthLowRes]=0;
			}
		}
		yh++;
		if (yh>=HeightLowRes) yh=HeightLowRes-1;
	}
	if (yh<HeightLowRes) {
		for (int j=yh;j<HeightLowRes;j++) {
			for (int i=0;i<WidthLowRes;i++) {
				objxLowRes[i+j*WidthLowRes]=0;
				objyLowRes[i+j*WidthLowRes]=0;
				objzLowRes[i+j*WidthLowRes]=0;
				BrightnessLowRes[i+j*WidthLowRes]=0;
			}
		}
	}

	//align the edges of the high res polygons with the edges of the low res polygons
	for (int yh=1;yh<(HeightLowRes-1);yh++) {
		for (int xh=1;xh<(WidthLowRes-1);xh++) {
			long x=xh*CameraPixelsPerPolygon;
			long y=yh*CameraPixelsPerPolygon;
			int CPPP=CameraPixelsPerPolygon;
			if (Resolution[x+y*Width]>1) {
				//this is a high res region
				//if top is low res: align top:
				if (Resolution[(x+(y-CPPP)*Width)]==1) {
					long StartAdr=x+y*Width;
					long StopAdr=x+CPPP+y*Width;
					double StartX=objx[StartAdr];
					double StopX=objx[StopAdr];
					double StartY=objy[StartAdr];
					double StopY=objy[StopAdr];
					double StartZ=objz[StartAdr];
					double StopZ=objz[StopAdr];
					for (int i=1;i<CPPP;i++) {
						objx[x+i+(y)*Width]=StartX+(((double)i)*(StopX-StartX))/CPPP;
						objy[x+i+(y)*Width]=StartY+(((double)i)*(StopY-StartY))/CPPP;
						objz[x+i+(y)*Width]=StartZ+(((double)i)*(StopZ-StartZ))/CPPP;
					}
				}
				//if left is low res: align left
				if (Resolution[x-CPPP+y*Width]==1) {
					long StartAdr=x+y*Width;
					long StopAdr=x+(y+CPPP)*Width;
					double StartX=objx[StartAdr];
					double StopX=objx[StopAdr];
					double StartY=objy[StartAdr];
					double StopY=objy[StopAdr];
					double StartZ=objz[StartAdr];
					double StopZ=objz[StopAdr];
					for (int i=1;i<CPPP;i++) {
						objx[x+(y+i)*Width]=StartX+(((double)i)*(StopX-StartX))/CPPP;
						objy[x+(y+i)*Width]=StartY+(((double)i)*(StopY-StartY))/CPPP;
						objz[x+(y+i)*Width]=StartZ+(((double)i)*(StopZ-StartZ))/CPPP;
					}
				}
				//if right is low res: align right
				if (Resolution[x+CPPP+y*Width]==1) {
					long StartAdr=x+CPPP+y*Width;
					long StopAdr=x+CPPP+(y+CPPP)*Width;
					double StartX=objx[StartAdr];
					double StopX=objx[StopAdr];
					double StartY=objy[StartAdr];
					double StopY=objy[StopAdr];
					double StartZ=objz[StartAdr];
					double StopZ=objz[StopAdr];
					for (int i=1;i<CPPP;i++) {
						objx[x+CPPP+(y+i)*Width]=StartX+(((double)i)*(StopX-StartX))/CPPP;
						objy[x+CPPP+(y+i)*Width]=StartY+(((double)i)*(StopY-StartY))/CPPP;
						objz[x+CPPP+(y+i)*Width]=StartZ+(((double)i)*(StopZ-StartZ))/CPPP;
					}
				}
				//if bottom is low res: align bottom:
				if (Resolution[x+(y+CPPP)*Width]==1) {
					long StartAdr=x+(y+CPPP)*Width;
					long StopAdr=x+CPPP+(y+CPPP)*Width;
					double StartX=objx[StartAdr];
					double StopX=objx[StopAdr];
					double StartY=objy[StartAdr];
					double StopY=objy[StopAdr];
					double StartZ=objz[StartAdr];
					double StopZ=objz[StopAdr];
					for (int i=1;i<CPPP;i++) {
						objx[x+i+(y+CPPP)*Width]=StartX+(((double)i)*(StopX-StartX))/CPPP;
						objy[x+i+(y+CPPP)*Width]=StartY+(((double)i)*(StopY-StartY))/CPPP;
						objz[x+i+(y+CPPP)*Width]=StartZ+(((double)i)*(StopZ-StartZ))/CPPP;
					}
				}
			}
		}
	}
	
	mtl<<"# Wavefront material file"<<endl;
	mtl<<endl;
	mtl<<"newmtl material_0"<<endl;
	mtl<<"Ka 0.200000 0.200000 0.200000"<<endl;
	mtl<<"Kd 1.000000 1.000000 1.000000"<<endl;
	mtl<<"Ks 1.000000 1.000000 1.000000"<<endl;
	mtl<<"Tr 1.000000"<<endl;
	mtl<<"illum 2"<<endl;
	mtl<<"Ns 0.000000"<<endl;
	char MaterialFileName[500];
	char TextureFilenameh[500];
	strcpy_s(TextureFilenameh,500,TextureFilename);
	int h=TextureFilename.GetLength();
	l=h;
	while ((l>0) && (TextureFilenameh[l-1]!='\\')) l--;
	for (unsigned int j=0;j<(h-l);j++) MaterialFileName[j]=TextureFilenameh[l+j];
	MaterialFileName[h-l]=0;
	mtl<<"map_Kd "<<MaterialFileName<<endl;
	
	//clean up vertices
	VerticeLowResOk=new bool[WidthLowRes*HeightLowRes];
	for (int y=0;y<HeightLowRes;y++) {
		for (int x=0;x<WidthLowRes;x++) {
			VerticeLowResOk[x+y*WidthLowRes]=(objzLowRes[x+y*WidthLowRes]>zMin) && (objzLowRes[x+y*WidthLowRes]<zMax) && (BrightnessLowRes[x+y*WidthLowRes]>(8*MinBrightness));
		}
	}
	VerticeOk=new bool[Width*Height];
	for (int y=0;y<Height;y++) {
		for (int x=0;x<Width;x++) {
			bool Needed=Resolution[x+y*Width]>1;
			if (x>0) {
				Needed=Needed || (Resolution[x-1+y*Width]>1);
				if (y>0) {
					Needed=Needed || (Resolution[x-1+(y-1)*Width]>1);
				}
			}
			if (y>0) {
				Needed=Needed || (Resolution[x+(y-1)*Width]>1);
			}
			VerticeOk[x+y*Width]=(objz[x+y*Width]>zMin) && (objz[x+y*Width]<zMax) && (Brightness[x+y*Width]>(8*MinBrightness)) && Needed;
		}
	}

	//Write .obj file
	
	char mtlFileNameOnly[500];
	h=(int)strlen(mtlFileName);
	l=h;
	while ((l>0) && (mtlFileName[l-1]!='\\')) l--;
	for (unsigned int j=0;j<(h-l);j++) mtlFileNameOnly[j]=mtlFileName[l+j];
	mtlFileNameOnly[h-l]=0;

	VertexNumberHighRes=new long[Width*Height];
	VertexNumberLowRes=new long[WidthLowRes*HeightLowRes];
	for (int x=0;x<Width;x++) for (int y=0;y<Height;y++) VertexNumberHighRes[x+y*Width]=-1;
	for (int x=0;x<WidthLowRes;x++) for (int y=0;y<HeightLowRes;y++) VertexNumberLowRes[x+y*WidthLowRes]=-1;
	obj<<"mtllib "<<mtlFileNameOnly<<endl;
	obj<<endl;
	unsigned long VerticeNumber=1;
	for (int y=0;y<HeightLowRes;y++) {
		if ((y % 10)==0) {
			CString buf;
			buf.Format("Write low res vertices line %04u / %04u",y,HeightLowRes);
			SetData(buf,y,HeightLowRes,4,9);
			if (StopCalculation) goto EndCalculation;
		}
		for (int x=0;x<WidthLowRes;x++) {
			if (VerticeLowResOk[x+y*WidthLowRes]) {
				obj<<"v "<<objxLowRes[x+y*WidthLowRes]<<" "<<objyLowRes[x+y*WidthLowRes]<<" "<<objzLowRes[x+y*WidthLowRes]<<endl;
				VertexNumberLowRes[x+y*WidthLowRes]=VerticeNumber;
				VerticeNumber++;
			}
		}
	}

	for (int y=0;y<Height;y++) {
		if ((y % 10)==0) {
			CString buf;
			buf.Format("Write high res vertices line %04u / %04u",y,Height);
			SetData(buf,y,Height,5,9);
			if (StopCalculation) goto EndCalculation;
		}
		for (int x=0;x<Width;x++) {
			if (VerticeOk[x+y*Width]) {
				obj<<"v "<<objx[x+y*Width]<<" "<<objy[x+y*Width]<<" "<<objz[x+y*Width]<<endl;
				VertexNumberHighRes[x+y*Width]=VerticeNumber;
				VerticeNumber++;
			}
		}
	}
	obj<<endl;

	//Write texture coordinates
	for (int y=0;y<HeightLowRes;y++) {
		if ((y % 10)==0) {
			CString buf;
			buf.Format("Write low res texture line %04u / %04u",y,HeightLowRes);
			SetData(buf,y,HeightLowRes,6,9);
			if (StopCalculation) goto EndCalculation;
		}
		for (int x=0;x<WidthLowRes;x++) {
			if (VertexNumberLowRes[x+y*WidthLowRes]>=0) {
				obj<<"vt "<<((double)x)/WidthLowRes<<" "<<(1-((double)y)/HeightLowRes)<<endl;
			}
		}
	}
	for (int y=0;y<Height;y++) {
		if ((y % 10)==0) {
			CString buf;
			buf.Format("Write high res texture line %04u / %04u",y,Height);
			SetData(buf,y,Height,7,9);
			if (StopCalculation) goto EndCalculation;
		}
		for (int x=0;x<Width;x++) {
			if (VertexNumberHighRes[x+y*Width]>=0) {
				obj<<"vt "<<((double)x)/Width<<" "<<(1-((double)y)/Height)<<endl;
			}
		}
	}
	obj<<endl;

	//f v0/vt0/vn0 v1/vt1/vn1
	double MaxPolygonDepthHighRes=MaxPolygonDepth;
	double MaxPolygonDepthLowRes=MaxPolygonDepth*CameraPixelsPerPolygon;
	for (int y=0;y<(HeightLowRes-1);y++) {
		if ((y % 10)==0) {
			CString buf;
			buf.Format("Write polygons line %04u / %04u",y,HeightLowRes);
			SetData(buf,y,HeightLowRes,8,9);
			if (StopCalculation) goto EndCalculation;
			
		}
		for (int x=0;x<(WidthLowRes-1);x++) {
			unsigned int xhighres=x*CameraPixelsPerPolygon;
			unsigned int yhighres=y*CameraPixelsPerPolygon;
			if (Resolution[xhighres+yhighres*Width]<2) {
				if ((VerticeLowResOk[x+y*WidthLowRes]) && (VerticeLowResOk[x+(y+1)*WidthLowRes]) && (VerticeLowResOk[x+1+(y+1)*WidthLowRes])) {
					double Dist1=fabs(objzLowRes[x+y*WidthLowRes]-objzLowRes[x+(y+1)*WidthLowRes]);
					double Dist2=fabs(objzLowRes[x+1+(y+1)*WidthLowRes]-objzLowRes[x+(y+1)*WidthLowRes]);
					double Dist3=fabs(objzLowRes[x+y*WidthLowRes]-objzLowRes[x+1+(y+1)*WidthLowRes]);
					if ((Dist1<MaxPolygonDepthLowRes) && (Dist2<MaxPolygonDepthLowRes) && (Dist3<MaxPolygonDepthLowRes))
					obj<<"f "<<VertexNumberLowRes[(x+y*WidthLowRes)]<<"/"<<VertexNumberLowRes[(x+y*WidthLowRes)]<<"/ "<<
							   VertexNumberLowRes[(x+(y+1)*WidthLowRes)]<<"/"<<VertexNumberLowRes[(x+(y+1)*WidthLowRes)]<<"/ "<<
							   VertexNumberLowRes[(x+1+(y+1)*WidthLowRes)]<<"/"<<VertexNumberLowRes[(x+1+(y+1)*WidthLowRes)]<<"/"<<endl;
				}
				if ((VerticeLowResOk[x+y*WidthLowRes]) && (VerticeLowResOk[x+1+y*WidthLowRes]) && (VerticeLowResOk[x+1+(y+1)*WidthLowRes])) {
					double Dist1=fabs(objzLowRes[x+y*WidthLowRes]-objzLowRes[x+1+y*WidthLowRes]);
					double Dist2=fabs(objzLowRes[x+1+y*WidthLowRes]-objzLowRes[x+1+(y+1)*WidthLowRes]);
					double Dist3=fabs(objzLowRes[x+y*WidthLowRes]-objzLowRes[x+1+(y+1)*WidthLowRes]);
					if ((Dist1<MaxPolygonDepthLowRes) && (Dist2<MaxPolygonDepthLowRes) && (Dist3<MaxPolygonDepthLowRes))
					obj<<"f "<<VertexNumberLowRes[(x+y*WidthLowRes)]<<"/"<<VertexNumberLowRes[(x+y*WidthLowRes)]<<"/ "<<
							   VertexNumberLowRes[(x+1+y*WidthLowRes)]<<"/"<<VertexNumberLowRes[(x+1+y*WidthLowRes)]<<"/ "<<
							   VertexNumberLowRes[(x+1+(y+1)*WidthLowRes)]<<"/"<<VertexNumberLowRes[(x+1+(y+1)*WidthLowRes)]<<"/"<<endl;
				}
			} else {
				for (int xh=0;xh<(int)CameraPixelsPerPolygon;xh++) {
					for (int yh=0;yh<(int)CameraPixelsPerPolygon;yh++) {

						//we have two choices for the diagonal separation of a square into two triangles. 
						//choose the one which gives more triangels
						long VAdr[6];
						VAdr[0]=xhighres+xh+(yhighres+yh)*Width; //top left
						VAdr[1]=xhighres+xh+(yhighres+yh+1)*Width; //Bottom left
						VAdr[2]=xhighres+xh+1+(yhighres+yh)*Width; //top right
						VAdr[3]=xhighres+xh+1+(yhighres+yh+1)*Width; //Bottom right

						bool Edge[6];
						Edge[0]=fabs(objz[VAdr[0]]-objz[VAdr[1]])<MaxPolygonDepthHighRes; //left
						Edge[1]=fabs(objz[VAdr[3]]-objz[VAdr[1]])<MaxPolygonDepthHighRes; //bottom
						Edge[2]=fabs(objz[VAdr[0]]-objz[VAdr[3]])<MaxPolygonDepthHighRes; //diagonal down
						Edge[3]=fabs(objz[VAdr[0]]-objz[VAdr[2]])<MaxPolygonDepthHighRes; //top
						Edge[4]=fabs(objz[VAdr[2]]-objz[VAdr[3]])<MaxPolygonDepthHighRes; //right
						Edge[5]=fabs(objz[VAdr[1]]-objz[VAdr[2]])<MaxPolygonDepthHighRes;  //diagonal up
						bool VOk[4];
						for (int i=0;i<4;i++) VOk[i]=VerticeOk[VAdr[i]];
							
							
						bool Choice1A=(Edge[0] && Edge[1] && Edge[2] && VOk[0] && VOk[1] && VOk[3]);//left / bottom / diag down
						bool Choice1B=(Edge[3] && Edge[4] && Edge[2] && VOk[0] && VOk[2] && VOk[3]);//top / right / diag down
						bool Choice2A=(Edge[0] && Edge[3] && Edge[5] && VOk[0] && VOk[1] && VOk[2]);//left / top / diag up
						bool Choice2B=(Edge[4] && Edge[1] && Edge[5] && VOk[3] && VOk[1] && VOk[2]);//right / bottom / diag up
						
						int SumChoice1=(Choice1A) ? 1 : 0 + (Choice1B) ? 1 : 0;
						int SumChoice2=(Choice2A) ? 1 : 0 + (Choice2B) ? 1 : 0;
						if (SumChoice1>=SumChoice2) {
							Choice2A=false;
							Choice2B=false;
						} else {
							Choice1A=false;
							Choice1B=false;
						}

						if (Choice1A) {
							obj<<"f "<<VertexNumberHighRes[VAdr[0]]<<"/"<<VertexNumberHighRes[VAdr[0]]<<"/ "<<
									   VertexNumberHighRes[VAdr[1]]<<"/"<<VertexNumberHighRes[VAdr[1]]<<"/ "<<
									   VertexNumberHighRes[VAdr[3]]<<"/"<<VertexNumberHighRes[VAdr[3]]<<"/"<<endl;
						}
						if (Choice1B) {
							obj<<"f "<<VertexNumberHighRes[VAdr[0]]<<"/"<<VertexNumberHighRes[VAdr[0]]<<"/ "<<
									   VertexNumberHighRes[VAdr[2]]<<"/"<<VertexNumberHighRes[VAdr[2]]<<"/ "<<
									   VertexNumberHighRes[VAdr[3]]<<"/"<<VertexNumberHighRes[VAdr[3]]<<"/"<<endl;
						}

						if (Choice2A) {
							obj<<"f "<<VertexNumberHighRes[VAdr[0]]<<"/"<<VertexNumberHighRes[VAdr[0]]<<"/ "<<
									   VertexNumberHighRes[VAdr[1]]<<"/"<<VertexNumberHighRes[VAdr[1]]<<"/ "<<
									   VertexNumberHighRes[VAdr[2]]<<"/"<<VertexNumberHighRes[VAdr[2]]<<"/"<<endl;
						}
						if (Choice2B) {
							obj<<"f "<<VertexNumberHighRes[VAdr[1]]<<"/"<<VertexNumberHighRes[VAdr[1]]<<"/ "<<
									   VertexNumberHighRes[VAdr[2]]<<"/"<<VertexNumberHighRes[VAdr[2]]<<"/ "<<
									   VertexNumberHighRes[VAdr[3]]<<"/"<<VertexNumberHighRes[VAdr[3]]<<"/"<<endl;
						}
					}
				}
			}
		}
	}
	
EndCalculation:
	obj.close();
	mtl.close();
	SetData("",0,1,0,4);

	PlaySound("sceamer.wav",NULL,SND_FILENAME);

	if (CameraPixelSizeY) delete[] CameraPixelSizeY;
	if (SumOfPixelSizeTillY) delete[] SumOfPixelSizeTillY;
	if (xCamAt) delete[] xCamAt;

	if (objxLowRes) delete[] objxLowRes;
	if (objyLowRes) delete[] objyLowRes;
	if (objzLowRes) delete[] objzLowRes;
	if (BrightnessLowRes) delete[] BrightnessLowRes;
	if (VerticeLowResOk) delete[] VerticeLowResOk;
	if (VerticeOk) delete[] VerticeOk;
	if (Brightness) delete[] Brightness;
	if (ResultImage) delete ResultImage;
	if (BrightnessImage) delete BrightnessImage;
	if (objx) delete[] objx;
	if (objy) delete[] objy;
	if (objz) delete[] objz;	
	if (SourcePicture) delete[] SourcePicture;
	if (BeamNrMatrix) delete[] BeamNrMatrix;
	if (DepthMap16Bit) delete[] DepthMap16Bit;
	if (Gradient) delete[] Gradient;
	if (Resolution) delete[] Resolution;
	if (VertexNumberHighRes) delete[] VertexNumberHighRes;
	if (VertexNumberLowRes) delete[] VertexNumberLowRes;
}

void CMySceamerDlg::OnBnClickedPerformScan()
{
	FullScreenDisplay(0);
}

void CMySceamerDlg::FullScreenDisplay(int aMode) {
	FullScreenMode=aMode;
	UpdateData(TRUE);
	SaveParameters();
	ModifyStyle(WS_CAPTION,0,0);
	ModifyStyleEx(0,WS_EX_TOPMOST,0);
	::ShowWindow(*this,SW_MINIMIZE);
	bFullscreen=!bFullscreen;
	::ShowWindow(*this,SW_MAXIMIZE);
}


void CMySceamerDlg::OnBnClickedStop()
{
	StopCalculation=true;
}

void CMySceamerDlg::OnStopscan()
{
	StopScan=true;
}

void CMySceamerDlg::OnUpdateStopscan(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(Scanning);
}

void CMySceamerDlg::OnBnClickedWhite()
{
	FullScreenDisplay(1);
}

void CMySceamerDlg::OnBnClickedScanlines()
{
	FullScreenDisplay(2);
}

void CMySceamerDlg::OnBnClickedGrid()
{
	FullScreenDisplay(3);
}

void CMySceamerDlg::OnBnClickedSceamerblog()
{
	Process::Start("http://www.sceamer.blogspot.com/");
}

void CMySceamerDlg::OnBnClickedHomepage()
{
	Process::Start("http://www.nintaka.com/");
}

