// SceamerDlg.h : header file
//

#pragma once
#include "afxcmn.h"


// CMySceamerDlg dialog
class CMySceamerDlg : public CDialog
{
// Construction
public:
	CMySceamerDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	enum { IDD = IDD_MYSceamer_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support


// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	virtual void OnCancel();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
public:
	UINT ScanlineDistance;
	// Width of light sheet in Beamer pixel
	UINT ScanlineHeight;
	// if true, make sound when scanlines are ready for next picture
	BOOL SoundForPicture;
	BOOL MouseClickForPicture;
	double TextureImageWait;
	double ScanlineImageWait;
	// Distance from beamer to maximum distance in meter
	double zScreen;

	// distance of upper boarder of beamer beams at maximum distance relative to beamer height in meter
	double yProj;
	
	// Height of beamer projection at zScreen in meter
	double wProj;
	
	// Number of lines of beamer
	UINT lProj;
	
	// distance between beamer and camera in meter. Camera lens is supposed to be vertically below beamer lens
	double yProjCam;
	
	// distance of first camera line in distance zScreen relative to height of beamer in meter
	double yCam;

	// width of top edge camera viewing area at zScreen
	double wCam;
	
	// camera line of highest beam on first picture as it hits zScreen
	UINT yScanTopCam;
	
	// yScanDistCam
	UINT yScanDistCam;
	
	// Texture filename. Scanline files are the subsequent files
	CString TextureFilename;
	
	CString ParameterFilename;
	
	// Minimum Brightness a pixel must have to be considered in the beam
	double MinBrightness;
	
	UINT CameraPixelsPerPolygon;
	
	// Minimum distance in meter for depthmap
	double zMin;
	
	// Maximum z distance for a valid polygon in meter
	double MaxPolygonDepth;
	
	bool bFullscreen;

	int FullScreenMode;
public:
	void Wait(DWORD Delay);
	void MouseClick();
public:
	afx_msg void OnBnClickedPerformScan();
	afx_msg void OnBnClickedCalculate();
	afx_msg void OnBnClickedLoad();
	afx_msg void OnBnClickedSave();
	afx_msg void OnBnClickedHelp();
	afx_msg void OnBnClickedBrowse();

	void SaveParameters();
	void LoadParameters();
	void SetData(CString text, int SubProgressPosition,int SubProgressMax,int Unit, int MaxUnits);
	void PumpMessages();
	void FullScreenDisplay(int aMode);
public:
	CProgressCtrl m_Progress;
public:
	CString Status;
public:
	afx_msg void OnBnClickedStop();
public:
	afx_msg void OnStopscan();
public:
	double zMax;
public:
	afx_msg void OnUpdateStopscan(CCmdUI *pCmdUI);
public:
	afx_msg void OnBnClickedWhite();
public:
	afx_msg void OnBnClickedScanlines();
public:
	afx_msg void OnBnClickedGrid();
public:
	afx_msg void OnBnClickedSceamerblog();
public:
	afx_msg void OnBnClickedHomepage();
public:
	UINT cProj;
public:
	double GradientThreshold;
};
